#pragma once

// STD/STL
#include <memory>
#include <numeric>
#include <string>

// Memory
#include <RobotAPI/libraries/aron/core/data/converter/nlohmannJSON/NlohmannJSONConverter.h>
#include <RobotAPI/libraries/aron/core/data/converter/variant/VariantConverter.h>
#include <RobotAPI/libraries/aron/core/data/rw/reader/nlohmannJSON/NlohmannJSONReader.h>
#include <RobotAPI/libraries/aron/core/data/rw/reader/variant/VariantReader.h>
#include <RobotAPI/libraries/aron/core/data/rw/writer/nlohmannJSON/NlohmannJSONWriter.h>
#include <RobotAPI/libraries/aron/core/data/rw/writer/variant/VariantWriter.h>
#include <RobotAPI/libraries/aron/core/data/variant/All.h>
#include <RobotAPI/libraries/aron/core/type/converter/nlohmannJSON/NlohmannJSONConverter.h>
#include <RobotAPI/libraries/aron/core/type/converter/variant/VariantConverter.h>
#include <RobotAPI/libraries/aron/core/type/rw/reader/nlohmannJSON/NlohmannJSONReader.h>
#include <RobotAPI/libraries/aron/core/type/rw/reader/variant/VariantReader.h>
#include <RobotAPI/libraries/aron/core/type/rw/writer/nlohmannJSON/NlohmannJSONWriter.h>
#include <RobotAPI/libraries/aron/core/type/rw/writer/variant/VariantWriter.h>

// JSON
#include <SimoxUtility/json/json.hpp>

namespace armarx::aron::data::converter
{
    using ToNLohmannJSONConverterVisitor =
        data::FromVariantConverter<data::writer::NlohmannJSONWriter>;

    using FromNLohmannJSONConverterVisitor =
        data::FromNlohmannJSONConverter<data::writer::VariantWriter>;
} // namespace armarx::aron::data::converter

namespace armarx::aron::type::converter
{
    using ToNLohmannJSONConverterVisitor =
        type::FromVariantConverter<type::writer::NlohmannJSONWriter>;

    using FromNLohmannJSONConverterVisitor =
        type::FromNlohmannJSONConverter<type::writer::VariantWriter>;
} // namespace armarx::aron::type::converter
